% 㷨
function mysort()

clear all;
n = 10000;
x = randi(10*n,n,1); % 

% n=100000;
% fid=fopen('data100000.dat','rb');
% x=fread(fid,[n,1],'int32');
% fclose(fid);

% Matlab Դ
% xt = sort(x); 
% fid=fopen('data100000sorted.dat','wb');
% fwrite(fid,xt,'int32');
% fclose(fid);

% return

% С
t0 = clock;
y = Sort_Min(x,n);
t = etime(clock,t0);
fprintf('С: time=%.4e\n',t);

% 
t0 = clock;
y = Sort_Insert(x,n);
t = etime(clock,t0);
fprintf(': time=%.4e\n',t);

% ϣshell
t0 = clock;
y = Sort_Shell(x,n);
t = etime(clock,t0);
fprintf('ϣ: time=%.4e\n',t);

% ð
t0 = clock;
y = Sort_Bubble(x, n);
t = etime(clock,t0);
fprintf('ð: time=%.4e\n',t);

% 
warning('off');
global x;
t0 = clock;
sort_quick(1,n);
t = etime(clock,t0);
fprintf(': time=%.4e\n',t);

%%%%% =====================================================================
function x = Sort_Min(x,n)
for k = 1 : n-1
    [xmin, ind] = min(x(k:n)); % ҳδ򲿷ֵСֵλ
    t = x(k); x(k) = x(k+ind-1); x(k+ind-1) = t; % 
end

%%%%% =====================================================================
% 
function x = Sort_Insert(x,n)
for k = 1 : n-1
    key = x(k+1); % ҪԪ
    i = k;
    while ( i > 0 && x(i) > key)
        x(i+1) = x(i); % ǰ k Ԫд x(k+1) ƶ
        i = i - 1;
    end
    x(i+1) = key; % ǰԪزʵλ
end

%%%%% =====================================================================
function x = Sort_Shell(x,n)
gap = floor(n/2); % 鳤ȵһ뿪ʼÿμСһ
while gap > 0
    for k = gap + 1 : n
        key = x(k); % ҪԪ
        i = k-gap;  % һΪstepԪؽв
        while ( i > 0 && x(i) > key)
            x(i+gap) = x(i);
            i = i - gap;
        end
        x(i+gap) = key; % ǰԪزʵλ
    end
    gap = floor(gap/2);
end

%%%%% =====================================================================
function x = Sort_Bubble(x,n)
for k = 1 : n
    flag = 0; % ڼ¼ǷҪԪ
    for i = 1 : n-k
        if x(i) > x(i+1)
            flag = 1;
            t = x(i); x(i) = x(i+1); x(i+1) = t;
        end
    end
    if flag==0  % αûԪҪ,ô
        break;
    end
end

%%%%% =====================================================================
function sort_quick(left,right)
global x

if left < right
    mid = partition(left, right);
    sort_quick(left, mid-1);
    sort_quick(mid+1, right);
end

function left = partition(left, right)
global x
% һΧѡһмԪ, ָԪ
% ִ꺯֮󷵻طָԪڵλ
% ڷָԪ֮ǰԪضСмԪ,
% ԪضڵмԪ

pivot = x(left); % еĵһԪΪмԪ
while (left < right)
    % Ӻǰ, ں벿ѰҵһСмԪصԪ
    while left<right && x(right) >= pivot
        right = right - 1;
    end
    % мԪСԪƵǰ벿
    if (left < right)
        x(left) = x(right); left = left + 1;
    end
    
    % ǰǰ벿ѰҵһмԪصԪ
    while left<right && x(left) < pivot
        left = left + 1;
    end
    % мԪشԪƵ벿
    if (left < right)
        x(right) = x(left); right = right - 1;
    end
end
x(left) = pivot;



        
